- https://cdn.pixabay.com/photo/2021/03/11/12/58/laptop-6087062_1280.png
- # Algorithmus-Eigenschaften
- #+BEGIN_QUOTE
  **Definition**<br />Ein Algorithmus ist eine Verarbeitungsvorschrift (Anweisung zum Handeln) zur Lösung eines Problems (mit Hilfe eines Computers), die folgenden Anforderungen erfüllt:
  #+END_QUOTE
	- **Allgemeingültigkeit**, d.h. die Anweisungen besitzen Gültigkeit für die Lösung einer ganzen Klasse von Problemen, nicht nur ein Einzelproblem
	- **Ausführbarkeit**, d.h. die Anweisungen sind für den Befehlsempfänger verständlich formuliert und für diesen ausführbar
	- **Eindeutigkeit**, d.h. an jeder Stelle ist der Ablauf der Anweisungen eindeutig festgelegt
	- **Finitheit**, d.h. die Anweisungsfolge ist durch einen endlichen Text beschrieben
	- **Terminiertheit**, d.h. nach endlich vielen Schritten liefert die Anweisungsfolge eine Lösung des gestellten Problems
	- **Determiniertheit**, d.h. bei jeder Ausführung mit gleichen Startbedingungen und Eingaben erhält man das gleiche Ergebnis
	-
- **Beispiele**
	- Verfahren der schriftlichen Addition
	- Testen eines Palindroms
	- Spielregeln eines Gesellschaftsspiels
-
- ## Schwierige Fälle
- <iframe width="560" height="415" src="https://www.youtube.com/embed/v3Xv-qJnp5o?si=AWKXh02Z3ZgJHkzB" title="YouTube video player" frameborder="0" allow="accelerometer; autoplay; clipboard-write; encrypted-media; gyroscope; picture-in-picture; web-share" referrerpolicy="strict-origin-when-cross-origin" allowfullscreen></iframe>
-
- ## Übung
- #+BEGIN_PINNED
  **Aufgabe**
  Vervollständige die Tabelle auch mit eigenen Beispielen. Finde dazu zwei Abläufe, die nicht den Anforderungen eines Algorithmus entsprechen.
  - Laufen im Kreis
  - Blindes Ziehen von 5 Kugeln aus einer Urne mit 8 Kugeln
  
  #+END_PINNED
- #+BEGIN_PINNED
  **Aufgabe**
  Testen wir mal dein Können in der interaktiven Übung.
  #+END_PINNED
- <iframe src="https://learningapps.org/watch?app=3986858" style="border:0px;width:100%;height:500px" webkitallowfullscreen="true" mozallowfullscreen="true"></iframe>
  
  
  <iframe src="https://learningapps.org/watch?app=5060037" style="border:0px;width:100%;height:500px" webkitallowfullscreen="true" mozallowfullscreen="true"></iframe>
  
  <iframe src="https://learningapps.org/watch?app=11308502" style="border:0px;width:100%;height:500px" webkitallowfullscreen="true" mozallowfullscreen="true"></iframe>
  
  <iframe src="https://learningapps.org/watch?app=1192152" style="border:0px;width:100%;height:500px" webkitallowfullscreen="true" mozallowfullscreen="true"></iframe>
- ## Darstellung von Algorithmen
  
  Warum muss ein Algorithmus überhaupt "gezeichnet" werden?
  
  i>Da es fast so viele Programmiersprachen wie Muttersprachen gibt, benötigt man einen "Dolmetscher". Dies ist die grafische Darstellung eines Algorithmus. Damit diese einheitlich umgesetzt wird, hat man sich auf Standards geeinigt, dies ist das **Struktogramm** (Nassi-Shneiderman-Diagramm) und das **Flussdiagramm**.
- **Struktogramm**
  
  ![alternativ](https://upload.wikimedia.org/wikipedia/commons/3/33/NassiShneiderman.png)
  
  *Quelle: https://upload.wikimedia.org/wikipedia/commons/3/33/NassiShneiderman.png, abgerufen am 31.08.2020*
- **Flussdiagramm**
  
  ![](https://upload.wikimedia.org/wikipedia/commons/thumb/6/6b/Flowchart_de.svg/1280px-Flowchart_de.svg.png){:height 429, :width 241} 
  
  *Quelle: https://de.wikipedia.org/wiki/Programmablaufplan#/media/Datei:Flowchart_de.svg*
  
  Im Unterricht werden wir uns auf das Zeichnen von **Flussdiagrammen** konzentrieren. Wobei zeichnen hier relativ zu sehen ist. Mit Hilfe des Programms **Flowgorithm** werden wir entsprechende Algorithmen entwickeln.