### Lernziel


#+BEGIN_QUOTE
* Du kennst verschiedene Datentypen für Zahlen.
* Du kennst die Bedeutung von boolschen Variablen.
* Du kannst Zeichenketten in Variablen speichern.
#+END_QUOTE 


---
- ## Zahlen
  
  | **Typ** | **Beschreibung** | **Wertebereich** | 
  | --- | --- | --- | 
  | `byte` | sehr kleine Zahl (8 Bit) | -128 bis 127 | 
  | `int` | große Zahlen (32 Bit) | -2147483648 bis 2147483647 | 
  | `float` | Zahl mit Nachkommastelle (32 Bit) | z.B. -0.5 ; 0 ; 109.333 | 
  | `double` | Zahl mit mehr Nachkommastellen (64 Bit) | 15 bis 16 Stellen | 
  
  #+BEGIN_WARNING
  Schreibe Gleitkommazahlen - so wie in England und USA üblich - mit einem Punkt. Also `1.5` statt `1,5`.
  #+END_WARNING
  
  
  #+BEGIN_TIP
  Mit einem sogenannten Cast kannst du einen bestimmten Datentyp vorgeben, z.B. eine Gleitkommazahl als ganze Zahl.
  #+END_TIP
  ```Java
  int x = (int) (3.9*2);
  ```
  
  Auf x wird nun die Zahl 7 gespeichert. Es werden alle Nachkommastellen gelöscht.
- ## Wahrheitswerte
  
  | **Typ** | **Beschreibung** | **Wertebereich** | 
  | --- | --- | --- | 
  | `boolean` | Wahrheitswert | `false und true` | 
  
  **Beispiel**
  ```Java
  boolean iLikeJava;
  boolean iLikeC;
  iLikeJava = true;
  iLikeC = false;
  println("Java: " + iLikeJava);
  println("C: " + iLikeC);
  ```
- ## Zeichen
  
  | Typ | Beschreibung | Wertebereich| 
  | --- | --- | --- | 
  | `char` | einzelnes Zeichen | z.B. `a` oder `%` | 
  
  Du kannst ein einzelnes Zeichen in einer Variable abspeichern. Das Zeichen wird immer mit einfachen Anführungszeichen umgeben:
  ```Java
  char c1 = 'a';
  char c2 = '5';
  char c3 = '%';
  println(c1 + c2 + c3);
  ```
  
  
  #+BEGIN_CAUTION
  Intern wird ein Zeichen als ganze Zahl repräsentiert. Diese Zahl entspricht einer standardisierten Tabelle. Für die handelsüblichen Buchstaben ist das zum Beispiel der **ASCII-Code** (ohne Umlaute). ASCII steht für "American Standard Code for Information Interchange" und ist ganz einfach eine Tabelle, wo für jedem Buchstaben/Zeichen eine Zahl zugeordnet wird. Heutzutage verwendet man das Unicode-System, welches für fast alle Sprachen der Welt entsprechende Buchstaben-/Zeicheneinträge hat. Eine konkrete Enkodierung von Unicode ist z.B. **UTF-8**.
  #+END_CAUTION
- ## Zeichenketten
  
  String ist englisch für "Schnur" oder "Kette". Das deutet darauf hin, dass ein String eine Aneinanderreihung von Zeichen (engl. character) ist. Man sagt deshalb auch Zeichenkette. Der Typ String wird im Gegensatz zu int, float, char ... groß geschrieben. Warum das so ist, erfährst du, sobald du Klassen und Objekte kennenlernst.
  
  In String-Variablen können Texte ablegt werden. Der Text wird mit doppelten Anführungszeichen gekennzeichnet:
  
  ```Java
  String foo = "Dies ist ein Text!";
  ```
  
  Du kannst Strings zusammenkleben, dies nennt man **String-Konkatenation** und funktioniert mit dem normalen Plus-Zeichen:
  
  ```Java
  String message = "hallo";
  println(message + " bob");
  ```
  
  ---
- ## Übung
  
  <iframe src="https://learningapps.org/watch?app=10189119" style="border:0px;width:100%;height:500px" webkitallowfullscreen="true" mozallowfullscreen="true"></iframe>