- #+BEGIN_IMPORTANT
  Sollten mehrere Entscheidungen nötig sein oder es mehr als zwei Fälle geben, verwendest du die geschachtelte Verzweigung als Lösungsmittel.
  #+END_IMPORTANT 
  
  ---
  
  Im Grunde genommen ist eine geschachtelte Verzweigung nichts wirklich neues. Doch langsam kommt das logische Denken ins Spiel. Wir müssen nun verschiedene algorithmische Grundstrukturen miteinander kombinieren.
  
  Nichts anderes ist eine **geschachtelte Verzweigung**.
  In einer Verzweigung steckt eine weitere. Dabei muss man jedoch stets überlegen, ob die neue Verzweigung in den THEN-Teil oder ELSE-Teil kommt. Deswegen musst du genau auf [[Boolesche Ausdruecke]] achten. 
  
  **Beispiel**
  
  ```Java
  ...
  int punkte = 75;
  ...
  
  if (punkte > 750){
     println("Mit Auszeichnung bestanden");
  } else {
     if(punkte > 300){
        println("Bestanden");
     } else {
        println("Durchgefallen");
     }
  }
  ...
  ```
  
  ![Flussdiagramm verschachtelte Verzweigung](../assets/verzweigungGeschachtelt.png)
  
  
  #+BEGIN_TIP
   **Tipp**: Meist ist es sinnvoll, die nötigen Fälle von größer zu kleiner bzw. von kleiner zu größer "abzuarbeiten". Ansonsten sind weitere Bedingungen oder mehr Verschachtelungen nötig.
  #+END_TIP
  ---
- Verschachtelungen können schnell überhand nehmen. Eine Möglichkeit, um zu viele Schachtelungen zu vermeiden und den Code übersichtlicher zu halten, ist [[Switch]].