- Variablen, die du überall in deinem Programm verwenden möchtest, heißen **globale Variablen**. Alle diese Variablen sollten im *aktiven Modus* immer ganz oben im Code stehen. Jeder Abschnitt deines Codes kann auf sie zugreifen und sie auch verändern.
  
  **Beispiel 1**
  
  ```Java
  // Alle Variablen ganz oben,
  // also vor setup und draw
  int x = 0;
  int y = 0;
  
  void setup() {}
  
  void draw() {
     ellipse(x, y, 20, 20);
     x++;
     y++;
  }
  ```
  
  
  #+BEGIN_WARNING
  Globale variablen stehen im aktiven Modus immer ganz oben im Code, außerhalb von setup, draw und anderen Funktionen.
  #+END_WARNING
  
  **Beispiel 2**
  
  ```Java
  int x; // neue globale Variable
  - // Anfangsposition festlegen
  void setup() {
   x = 0;
  }
  - // Ball animieren
  void draw() {
   background(255);
   ellipse(x, 50, 20, 20);
   x++;
  }
  - // Ball zurücksetzen
  void keyPressed() {
   x = 0;
  }
  ```
  
  
  #+BEGIN_NOTE
  Variable `x` nennt man eine globale Variable, weil überall, also global, im Programm verwendet werden kann. In unserem Beispiel wird `x` in drei verschiedenen Funktionen (setup, draw und keyPressed) verwendet.
  #+END_NOTE