- ![Code Einführung Unterprogramme](../assets/code_php.png)
  
  Im Abschnitt [[Eigene Funktionen]] ist nur die einfachste Variante von Funktionen beschrieben. Wenn du den Befehl `rect` anschaust, dann bekommt der Befehl noch einige Informationen mit auf den Weg, nämlich Eckpunkte, Breite und Höhe:
  
  ```Java
  rect(50, 50, 100, 80);
  ```
  
  Diese Zusatzinformationen nennt man **Parameter**. Parameter geben dir die Möglichkeit, viele Varianten einer Aufgabe (Größe des Haus des Nikolaus) mit der selben Funktion (hausDesNikolaus) zu erfassen, in dem dir jeweils spezifische Ausprägungen in den Parametern gesetzt wird.
- ### Parameter in der Funktionsdefinition
  
  Damit deine Funktion Parameter entgegennehmen kann, müssen diese bei der Funktionsdefinition mitdefiniert werden. Zum Beispiel willst du der Gesichtsfunktion die Augenfarbe mitgeben:
  
  ```Java
  void zeichneGesicht(int augenfarbe) {
    fill(255); // weiß
    ellipse(x, y, 80, 80); // Gesicht
    fill(augenfarbe);
    ellipse(x-15, y-15, 20, 20); // Auge
    ellipse(x+15, y-15, 20, 20); // Auge
  }
  ```
  
  Du siehst, dass in den Klammern zwei Dinge hinzugefügt wurden: den **Datentyp** des Parameters und den **Namen**. Im Grund ist das exakt das gleiche wie bei einer Variable.
  
  Und tatsächlich: der Parameter `augenfarbe` **ist** eine lokale Variable.
  
  Das heißt, dass diese Variable eine begrenzte Lebensdauer (Skopus) hat. Sie beginnt mit der öffnenden geschweiften Klammer und endet bei der schließenden.
  
  **Mehrere Parameter** werden durch Kommata getrennt.
  
  Beispiel:
  
  ```Java
  void zeichneGesicht2(int gesichtsfarbe, int augenfarbe) {
    fill(gesichtsfarbe);
    ellipse(x, y, 80, 80); // Gesicht
    fill(augenfarbe);
    ellipse(x-15, y-15, 20, 20); // Auge
    ellipse(x+15, y-15, 20, 20); // Auge
  }
  ```
  
  
  #+BEGIN_WARNING
  **Parameter nicht verändern**
  Verändere niemals den Parameter innerhalb einer Funktion! Dies ist zwar möglich - aber schlechter Stil und kann bei längerem Code zu Verwirrung führen. Führe in einem solchen Falle lieber eine neue Variable ein.
  #+END_WARNING
- ### Aufruf mit Parameter
  
  Beim Aufruf einer Funktion mit Parametern musst du darauf achten, dass du genau die Information mitgibst, die deine Definition verlangt. Das heißt, **die Anzahl, Reihenfolge und Datentyp der Parameter müssen mit den Angaben deines Funktionsaufrufs übereinstimmen**.
- ## Übung
  
  
  #+BEGIN_IMPORTANT
  Teste alle Funktionen mit jeweiligem Aufruf.
  #+END_IMPORTANT 
  
  #+BEGIN_PINNED
  **Aufgabe 1 - Kreis 1**
  Schreibe eine eigene Funktion `kreis()`, welche an eine vom Nutzer vorgegebene Position einen Kreis mit einem Durchmesser von 20 Pixel zeichnet.
  #+END_PINNED 
  
  ```Java
  Dein Code
  ```
  
  #+BEGIN_PINNED
  **Aufgabe 2 - Kreis 2**
  Schreibe eine eigene Funktion `kreis()`, welche an eine vom Nutzer vorgebene Position einen Kreis mit einem vom Nutzer zu definierendem Radius zeichnet.
  #+END_PINNED 
  
  ```Java
  Dein Code
  ```
  
  #+BEGIN_PINNED
  **Aufgabe 3 - Haus des Nikolaus**
  Erzeuge eine Funktion mit Parameter, welche das Haus des Nikolaus mit einem Streckungsfaktor zeichnet.
  #+END_PINNED 
  
  ```Java
  Dein Code
  ```