- Du könntest auf die Idee kommen, sowohl [[Bedingte Schleifen]] als auch [[Zaehlschleifen]] im aktiven Modus, also in der draw()-Methode einzusetzen.
  
  
  #+BEGIN_IMPORTANT
  In Processing benutzt man Schleifen normalerweise **nicht für Animationen**. Du könntest dennoch auf die Idee kommen, einen Ball innerhalb von einer For-Schleife zu animieren.
  #+END_IMPORTANT
  
  ```Java
  // (vergeblicher) Versuch einer Animation
  
  int x = 0;
  
  void setup() {
     frameRate(1); // 1x pro Sek. draw() aufrufen
  }
  
  void draw() {
     for (int i = 0; i < 100; i++) {
        background(255);
        ellipse(x, 50, 10, 10);
        x++;
     }
     // erst jetzt wird das Werk sichtbar!
  }
  ```
  
  Hier ist die Frame-Rate auf 1 gesetzt, d.h. `draw()` wird jede Sekunde aufgerufen. Du siehst eine Sekunde den Ball in seiner "Endposition" und danach wird es weiß. Warum?
  Weil Processing am Ende von `draw()` die Zeichnung sichtbar macht. Alles was innerhalb von `draw()` passiert, ist somit unsichtbar, bis die schließende geschweifte Klammer von `draw()` erreicht ist.
  
  Sinnvoller ist es daher, wiederkehrende grafische Elemente mit Hilfe von Schleifen zu erstellen. So kann man beispielsweise drei Rechtecke gleichzeitig malen:
  
  ```Java
  // Drei Rechtecke mit Schleife
  
  int x = 0;
  
  void draw() {
     background(255);
  
     // zeichne drei Rechtecke, i läuft von 1..3
     for (int i = 1; i <= 3; i++) {
        rect(x, i * 20, 10, 10); // jedes hat andere y-Position
     }
  
     // passe x-Wert an für Animation
     x++;
  }
  ```
  
  
  #+BEGIN_PINNED
  **Aufgabe 1**
  Fülle den Schreibtischtest aus.
  #+END_PINNED 
  
  *Lösung*
  
  | **Durchlauf Nr.** | **Wert von i** | **i <= 3** | **ausgeführter Code** | 
  | --------------|------------|--------|------------------ | 
   |       1       |            |        |   | 
   |       2      |            |        |   | 
   |       ...      |            |        |   | 
  
  
  #+BEGIN_PINNED
  **Aufgabe 2**
  Beschreibe das Verhalten der drei Rechtecke innerhalb des Schleifenzyklus bzw. der draw()-Methode.
  #+END_PINNED 
  
  *Lösung*
  ...