### Lernziel


#+BEGIN_QUOTE
Du wendest verschiedene Systemvariablen an, um flexibler auf Programmeigenschaften wie die Fenstergröße reagieren zu können.
#+END_QUOTE 
---

Processing ist so freundlich, eine Handvoll Variablen zu "schenken". Diese Variablen können stets abgerufen werden. Eine dir bereits bekannte solche Variable ist `mouseX`.
- ## Größe des Grafikfensters
  
  Hier ein Beispiel, wo Sie ein Rechteck malen, das das linke obere Viertel des Bildschirms besetzt. Du benutzet die Systemvariablen `width` und `height`, welche die Breite und Höhe Ihres Grafikfensters beinhalten:
  
  ```Java
  rect(0, 0, width/2, height/2);
  ```
  
  
  #+BEGIN_WARNING
  Achte darauf, dass die Systemvariable width und height erst ab setup() zur Verfügung stehen.
  #+END_WARNING 
  
  ```Java
  int w = width;  // Problem! width noch nicht gesetzt!
  int h = height; // Problem! height noch nicht gesetzt!
  
  void setup() {
  }
  
  void draw() {
     ellipse(w/2, h/2, 40, 40);
  }
  ```
- ## Mausposition
  
  | Befehl | Rückgabewert | 
  | ------ | ------------ | 
  | mouseX | aktuelle X-Position der Maus | 
  | mouseY | aktuelle Y-Position der Maus | 
  | pmouseX | vorherige X-Position der Maus | 
  | pmouseY | vorherige Y-Position der Maus |
- ## Refresh-Geschwindigkeit
  
  Einen Aufruf von draw() nennt man auch einen **Frame**. Normalerweise wird draw() 60 mal pro Sekunde aufgerufen. Die aktuelle Rate kann man mit `frameRate` auslesen.
- ## Weitere Systemvariablen
  
  | Befehl | Rückgabewert | 
  | ------ | ------------ | 
  | key | zuletzt gedrückte Taste | 
  | keyPressed | ob eine Taste derzeit gedrückt ist | 
  | mousePressed | ob ein Mausbutton derzeit gedrückt ist | 
  | mouseButton | welche der Maustasten aktuell gedrückt ist | 
  | displayHeight, displayWidth | Maße des gesamten Bildschirms in Pixeln |
- ### Übung
  
  
  #+BEGIN_PINNED
  **Aufgabe 1 - Zeichen-Ticker**
  Zeichne die zuletzt gedrückte Taste in die Mitte des Grafikfensters.
  #+END_PINNED 
  
  ```Java
  Deine Lösung
  ```
  
  #+BEGIN_PINNED
  **Aufgabe 2 - Mitte**
  Zeichne einen Kreis, der sich genau in der Mitte des Fensters befindet, auch wenn die Fenstergröße verändert wird.
  #+END_PINNED 
  
  ```Java
  Deine Lösung
  ```
  
  #+BEGIN_PINNED
  **Aufgabe 3 - Zähler**
  Unter der Annahme, dass die `frameRate` konstant bleibt, kannst du mit `frameCount` einen Sekundenzähler realisieren. Bei Mausklick soll der Zähler auf 0 springen.
  #+END_PINNED 
  
  ```Java
  Deine Lösung
  ```