- ![Zufall-Banner](../assets/zufall-banner.jpg)
- ### Lernziele
  
  
  #+BEGIN_QUOTE
  * Du verstehst, wie der Computer eine zufällige Zahl generiert.
  * Du kannst eine zufällige Zahl mit dem Computer generieren.
  * Du kannst Zufallszahlen zielgerichtet einsetzen (bspw. beim Platzieren von Objekten oder der Farbgenerierung).
  #+END_QUOTE
  
  ---
- ## Basiswissen
  
  Zufall ist ja so eine ganz spezielle Sache in der Informatik.
  Es stellt sich die Frage, ob wir überhaupt von generiertem Zufall sprechen „dürfen“.
  
  
  #+BEGIN_PINNED
  **Aufgabe**
  Was versteht man unter "Pseudozufall"?
  #+END_PINNED 
  
  *Lösung*
  ...
  
  Dennoch bietet es sich an, immer wieder „Unvorhersehbares“ in Programmen zu integrieren. Dazu bietet uns Processing folgenden Befehl `random()`. Diese Funktion gibt an der notierten Stelle eine entsprechende Zufallszahl zurück.
  Folgende Abwandlungsmöglichkeiten stehen uns zur Verfügung:`
  * fill(random(255));` //zufällige Zahl aus {0,1,…,255}
  * Der Befehl `random()` gibt eine float-Zahl (Kommazahl) zwischen 0 und 1 zurück.
  * Der Befehl `random(-5,5)` erzeugt eine float-Zahl zwischen -5 und 5.
  
  #+BEGIN_TIP
  **Tipp:** 
  `double d = random(0,1);` //erzeugt eine Zufallszahl zwischen 0 und 1.
  `(int)` beschneidet die Nachkommastellen
  `double d = (int) (random(3,6)+1);` erzeugt eine Zufallszahl  zwischen 3 und 6.
  #+END_TIP 
  ---
- ## Übung
  
  
  #+BEGIN_PINNED
  **Aufgabe 1 - Konfetti**
  Erzeuge einen Konfetti-Regen, bei dem viele bunte Punkte an vielen zufälligen Stellen entstehen.
  #+END_PINNED 
  
  ```Java
  Deine Lösung
  ```
  
  #+BEGIN_PINNED
  **Aufgabe 2 - Zufallskästchen**
  Bei Mausklick soll an zufälliger Position ein Kasten erscheinen, mit zufälliger Breite und Höhe (je zwischen 5 und 40 Pixel).
  #+END_PINNED
  
  ```Java
  Deine Lösung
  ```
  
  #+BEGIN_PINNED
  **Aufgabe 3 - Spielwürfel**
  Erzeuge einen Würfel, welcher die Augenzahl in der Konsole ausgibt.
  Der Datentyp Integer (`int`) beinhaltet alle ganzen Zahlen.
  #+END_PINNED
  
  ```Java
  Deine Lösung
  ```
  
  #+BEGIN_PINNED
  **Aufgabe 4 - Gezinkter Würfel**
  Erzeuge einen Würfel, der die Augenzahl grafisch anzeigt. Beim Drücken der Taste R (für rollen) soll er eine zufällige Augenzahl zwischen 1 und 6 anzeigen. Beim Drücken der Tasten 1, 2, 3 usw. soll er die entsprechende Zahl anzeigen.
  #+END_PINNED
  
  ```Java
  Deine Lösung
  ```
  
  #+BEGIN_PINNED
  **Aufgabe 4.1 - Animation**
  Füge deinem Würfel aus Aufgabe 4 eine selbstgewählte Animation hinzu, die suggeriert, dass der Würfel wirklich geworfen wird und das Ergebnis zufällig ist. Zeige z.B. schnell hintereinander verschiedene Augenzahlen an, bis der Würfel auf einer Seite "liegen bleibt". Achtung, das ist in Processing gar nicht so einfach, da immer nur das Endergebnis angezeigt wird, wenn die gesamte draw()-Methode durchlaufen wurde.
  #+END_PINNED
  
  ```Java
  Deine Lösung
  ```